Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 859)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 861)
@@ -558,97 +532,95 @@
           swap_flux_x_local(k,j,tn) = flux_r(k)
           swap_diss_x_local(k,j,tn) = diss_r(k)
-          
+          flux_d                    = flux_t(k)
+          diss_d                    = diss_t(k)
+
        ENDDO
-
-!
-!--    Vertical advection, degradation of order near bottom and top. 
-!--    The fluxes flux_d and diss_d at the surface are 0. Due to later
-!--    calculation of statistics the top flux at the surface should be 0.
-       flux_t(nzb_s_inner(j,i)) = 0.0
-       diss_t(nzb_s_inner(j,i)) = 0.0
-
-!       
-!--    2nd-order scheme (bottom)
-       k         = nzb_s_inner(j,i)+1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       flux_t(k) = w(k,j,i) * ( sk(k+1,j,i) + sk(k,j,i) ) * 0.5
-
-!       
-!--    sk(k,j,i) is referenced three times to avoid an access below surface
-       diss_t(k) = diss_2nd( sk(k+2,j,i), sk(k+1,j,i), sk(k,j,i), sk(k,j,i),  &
-                             sk(k,j,i), w(k,j,i), 0.5, ddzw(k) )
-                   
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k) - flux_d - diss_d ) &
-                                   * ddzw(k)
-!
-!--    WS3 as an intermediate step (bottom)
-       k         = nzb_s_inner(j,i) + 2
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       flux_t(k) = w(k,j,i) * (                                               &
-                                7.0 * ( sk(k+1,j,i) + sk(k,j,i)   )           &
-                                    - ( sk(k+2,j,i) + sk(k-1,j,i) )           &
-                              ) * adv_sca_3
-       diss_t(k) = -ABS( w(k,j,i) ) * (                                       &
-                                3.0 * ( sk(k+1,j,i) - sk(k,j,i)   )           & 
-                                    - ( sk(k+2,j,i) - sk(k-1,j,i) )           &
-                                      ) * adv_sca_3
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k) - flux_d - diss_d ) &
-                                   * ddzw(k)
-!
-!--    WS5
-       DO  k = nzb_s_inner(j,i)+3, nzt-2
-       
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)          
-          flux_t(k) = w(k,j,i) * (                                            &
-                                   37.0 * ( sk(k+1,j,i) + sk(k,j,i)   )       &
-                                 -  8.0 * ( sk(k+2,j,i) + sk(k-1,j,i) )       &
-                                 +        ( sk(k+3,j,i) + sk(k-2,j,i) )       &
-                                 ) * adv_sca_5
-          diss_t(k) = -ABS( w(k,j,i) ) * (                                     &
-                                           10.0 * ( sk(k+1,j,i) - sk(k,j,i)   )&
-                                         -  5.0 * ( sk(k+2,j,i) - sk(k-1,j,i) )&
-                                         +        ( sk(k+3,j,i) - sk(k-2,j,i) )&
-                                         ) * adv_sca_5
-
-          tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k)                 &
-                                    - ( flux_d + diss_d ) ) * ddzw(k)
+!
+!--    Now compute the fluxes and tendency terms for the horizontal and
+!--    vertical parts above the top of the highest topography. No degradation
+!--    for the horizontal parts, but for the vertical it is stell needed.
+       DO  k = nzb_max+1, nzt
+
+          u_comp    = u(k,j,i+1) - u_gtrans
+          flux_r(k) = u_comp * (                                            &
+                      37.0 * ( sk(k,j,i+1) + sk(k,j,i)   )                  &
+                    -  8.0 * ( sk(k,j,i+2) + sk(k,j,i-1) )                  &
+                    +        ( sk(k,j,i+3) + sk(k,j,i-2) ) ) * adv_sca_5
+          diss_r(k) = -ABS( u_comp ) * (                                    &
+                      10.0 * ( sk(k,j,i+1) - sk(k,j,i)   )                  &
+                    -  5.0 * ( sk(k,j,i+2) - sk(k,j,i-1) )                  &
+                    +        ( sk(k,j,i+3) - sk(k,j,i-2) ) ) * adv_sca_5
+
+          v_comp    = v(k,j+1,i) - v_gtrans
+          flux_n(k) = v_comp * (                                            &
+                      37.0 * ( sk(k,j+1,i) + sk(k,j,i)   )                  &
+                    -  8.0 * ( sk(k,j+2,i) + sk(k,j-1,i) )                  &
+                    +        ( sk(k,j+3,i) + sk(k,j-2,i) ) ) * adv_sca_5
+          diss_n(k) = -ABS( v_comp ) * (                                    &
+                      10.0 * ( sk(k,j+1,i) - sk(k,j,i)   )                  &
+                    -  5.0 * ( sk(k,j+2,i) - sk(k,j-1,i) )                  &
+                    +        ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * IBITS(wall_flags_0(k,j,i),8,1)
+          k_pp  = k + 2 * ( 1 - IBITS(wall_flags_0(k,j,i),6,1)  )
+          k_mm  = k - 2 * IBITS(wall_flags_0(k,j,i),8,1)
+
+          flux_t(k) = w(k,j,i) * (                                          &
+                     ( 37.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     7.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)  + sk(k,j,i)   )                 &
+              -      (  8.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i) )                 &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                &
+                                 )
+
+          diss_t(k) = -ABS( w(k,j,i) ) * (                                  &
+                     ( 10.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +     3.0 * IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                  +           IBITS(wall_flags_0(k,j,i),6,1) * adv_sca_1    &
+                     ) *                                                    &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )               &
+              -      (  5.0 * IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                  +           IBITS(wall_flags_0(k,j,i),7,1) * adv_sca_3    &
+                     ) *                                                    &
+                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )               &
+              +      (        IBITS(wall_flags_0(k,j,i),8,1) * adv_sca_5    &
+                     ) *                                                    &
+                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )               &
+                                         )
+!
+!--       Calculate the divergence of the velocity field. A respective
+!--       correction is needed to overcome numerical instabilities introduced
+!--       by a not sufficient reduction of divergences near topography.
+          div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx                   &
+                        + ( v(k,j+1,i) - v(k,j,i)   ) * ddy                   &
+                        + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+
+          tend(k,j,i) = tend(k,j,i) - (                                       &
+                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
+                          swap_diss_x_local(k,j,tn)            ) * ddx        &
+                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
+                          swap_diss_y_local(k,tn)              ) * ddy        &
+                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
+                                                               ) * ddzw(k)    &
+                                      ) + sk(k,j,i) * div
+
+          swap_flux_y_local(k,tn)   = flux_n(k)
+          swap_diss_y_local(k,tn)   = diss_n(k)
+          swap_flux_x_local(k,j,tn) = flux_r(k)
+          swap_diss_x_local(k,j,tn) = diss_r(k)
+          flux_d                    = flux_t(k)
+          diss_d                    = diss_t(k)
 
        ENDDO
 
 !
-!--    WS3 as an intermediate step (top)
-       k         = nzt - 1
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       flux_t(k) = w(k,j,i) * (                                                &
-                                7.0 * ( sk(k+1,j,i) + sk(k,j,i)   )            &
-                                    - ( sk(k+2,j,i) + sk(k-1,j,i) )            &
-                              ) * adv_sca_3
-       diss_t(k) = -ABS( w(k,j,i) ) * (                                        &
-                                        3.0 * ( sk(k+1,j,i) - sk(k,j,i)   )    &
-                                            - ( sk(k+2,j,i) - sk(k-1,j,i) )    &
-                                      ) * adv_sca_3
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k) - flux_d - diss_d ) &
-                                   * ddzw(k)
-!                                 
-!--    2nd-order scheme (top)
-       k         = nzt 
-       flux_d    = flux_t(k-1)
-       diss_d    = diss_t(k-1)
-       flux_t(k) = w(k,j,i) * ( sk(k+1,j,i) + sk(k,j,i) ) * 0.5
-
-!       
-!--    sk(k+1) is referenced two times to avoid a segmentation fault at top
-       diss_t(k) = diss_2nd( sk(k+1,j,i), sk(k+1,j,i), sk(k,j,i), sk(k-1,j,i), &
-                             sk(k-2,j,i), w(k,j,i), 0.5, ddzw(k) )
-
-       tend(k,j,i) = tend(k,j,i) - ( flux_t(k) + diss_t(k) - flux_d - diss_d ) &
-                                   * ddzw(k)
-!       
 !--    Evaluation of statistics
        SELECT CASE ( sk_char )
@@ -656,6 +628,6 @@
           CASE ( 'pt' )
 
-             DO  k = nzb_s_inner(j,i), nzt
-                sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn) +                      &
+             DO  k = nzb, nzt
+                sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn) +                &
                                        ( flux_t(k) + diss_t(k) )               &
                                  * weight_substep(intermediate_timestep_count)
@@ -664,6 +636,6 @@
           CASE ( 'sa' )
 
-             DO  k = nzb_s_inner(j,i), nzt
-                sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn) +                      &
+             DO  k = nzb, nzt
+                sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn) +                &
                                        ( flux_t(k) + diss_t(k) )               &
                                  * weight_substep(intermediate_timestep_count)
@@ -672,6 +644,6 @@
           CASE ( 'q' )
 
-             DO  k = nzb_s_inner(j,i), nzt
-                sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn) +                       &
+             DO  k = nzb, nzt
+                sums_wsqs_ws_l(k,tn)  = sums_wsqs_ws_l(k,tn) +                 &
                                       ( flux_t(k) + diss_t(k) )                &
                                  * weight_substep(intermediate_timestep_count)
